#! /usr/bin/env node
if (!process.argv[2]) {
    console.log("no package indicated");
    return;
}
const { exec } = require('child_process');
const fs = require('fs');
const cwd = require('path').resolve();
const glob = require("glob");

const packagesToInstall = process.argv.splice(2);
var loadNpmPackageDir = packagesToInstall.filter(function(v){
    if(v.indexOf("loadNpmPackage-dir") > -1 )
        return v;
});
var dirname = cwd + "/loadNpmPackages/";
if( loadNpmPackageDir.length ){
    dirname = cwd + "/" + loadNpmPackageDir[0].split("=")[1] + "/";
    packagesToInstall
        .splice(packagesToInstall.indexOf(loadNpmPackageDir[0]),1);
}

if (!fs.existsSync(dirname))
    fs.mkdirSync(dirname);

exec('npm install ' + packagesToInstall.join(" "), (error, stdout, stderr) => {
    if (error) {
        console.error(`npm install error: ${error}`);
        return;
    }
    console.log("packagesToInstall ->",packagesToInstall);
    for(var i = 0; i<packagesToInstall.length;i++){
        var packageDir = cwd + "/node_modules/" + packagesToInstall[i] + "/";
        var globFiles = require(packageDir + "/package.json").files || [];
        console.log("packages",globFiles);
        for(var g in globFiles)
            (function(globFile,packageName) {
                glob(packageDir + globFile, function (er, files) {
                    if (er) {
                        console.error(`glob error: ${er}`);
                        return;
                    }
                    console.log("glob files",files);
                    for (var f in files) {
                        var splitted = files[f].split(/[/\\]/g);
                        var dirnamePkg = dirname + packageName + "/";
                        if (!fs.existsSync(dirnamePkg))
                            fs.mkdirSync(dirnamePkg);
                        fs.createReadStream(files[f])
                            .pipe(fs.createWriteStream(dirnamePkg +
                                splitted[splitted.length - 1]));
                    }
                })
            })(globFiles[g],packagesToInstall[i]);
    }
});

